"""
Install method

$Id: Install.py 24392 2006-06-04 17:03:45Z dbaty $
"""

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.CMFNotification.config import PROJECT_NAME, GLOBALS, DEFAULT_ROLES
from Products.CMFNotification.permissions import SUBSCRIBE_PERMISSION
from Products.CMFNotification.NotificationTool import META_TYPE, ID
from Products.CMFNotification.NotificationTool import NotificationTool

try:
    from Products.Archetypes.Extensions.utils import install_subskin
    HAS_ARCHETYPES = True
except ImportError:
    HAS_ARCHETYPES = False

def install(self):
    """
    Install this product
    """
    out = StringIO()

    if HAS_ARCHETYPES:
        install_subskin(self, out, GLOBALS)
    else:
        raise NotImplementedError

    ## Add tool
    portal = getToolByName(self, 'portal_url').getPortalObject()
    if getToolByName(portal, ID, None) is None:
        t = NotificationTool()
        portal._setObject(ID, t)

    ## Add portlet to the right slots.
    right_slots = list(portal.getProperty('right_slots'))
    right_slots.insert(0, 'here/portlet_notification/macros/portlet')
    portal.manage_changeProperties(right_slots=right_slots)

    ## Set default roles for subscribe permission
    portal.manage_permission(SUBSCRIBE_PERMISSION, DEFAULT_ROLES)

    print >> out, "Successfully installed %s." % PROJECT_NAME
    return out.getvalue()
